import java.util.Scanner;

public class DigitProductSequence {

	private static int find_next(int base, int n) {
		int prod = 1;
		int remainder = n;

		while(remainder >= base) {
			int mod = remainder % base;
			if(mod != 0)
				prod *= mod;
			remainder = (remainder - mod) / base;
		}
		if(remainder != 0)
			prod *= remainder;
		return n + prod;
	}

	private static int solveDSPSequence(int base, int seq) {

		/* ------------------- INSERT CODE HERE ---------------------*/

		/* For the Digit Product Sequence using Base = base, find and return the next number 
		 * after seq
		 */

		return find_next(base, seq);

		/* -------------------- END OF INSERTION --------------------*/

		// return -1;
	}

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);

		int numCases = sc.nextInt();

		for(int n = 0; n < numCases; n++)
		{
			int base = sc.nextInt();
			int seq = sc.nextInt();
			System.out.println("In Base " + base + " DSP sequence, the number after " +  seq + " is " +  solveDSPSequence(base, seq));
		}

		sc.close();
	}
}
